## udev 147~-6

=== debian/changelog ===
udev (147~-6) karmic; urgency=low

  * debian/udev.initramfs-hook:
    - Include the firmware helper.  LP: #381037.

 -- Scott James Remnant <scott@ubuntu.com>  Thu, 15 Oct 2009 20:47:20 +0100

udev (147~-5) karmic; urgency=low

  * debian/udev.initramfs-top:
    - Rename from udev.initramfs-bottom and move from local-premount to
      init-top
    - Add a pre-requisite on all_generic_ide so that gets a chance before
      we load IDE devices.
  * rules/rules.d/80-drivers.rules:
    - load the fbcon driver when a framebuffer is created.
      LP: #392039, #431812.

 -- Scott James Remnant <scott@ubuntu.com>  Wed, 23 Sep 2009 14:22:52 -0700

udev (147~-4) karmic; urgency=low

  * Update to GIT HEAD (still pre 147 release):
    - fix signal mask harder.  LP: #407428, #434852.

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 22 Sep 2009 22:45:39 +0100

udev (147~-3) karmic; urgency=low

  * Update to GIT HEAD (still pre 147 release):
    - includes fix from previous revision
    - rename interfaces to <iface>_rename if rename fails.  LP: #416782.
    - drop most NAME keys since 2.6.31 supplies them.
    - especially those with just "%k".  LP: #430654.
    - fixed SYMLINK option parsing.  LP: #430654.

  * Remove 40-alsa.rules now it's not shipped upstream.

 -- Scott James Remnant <scott@ubuntu.com>  Mon, 21 Sep 2009 16:02:32 -0700

udev (147~-2) karmic; urgency=low

  * rules/rules.d/60-persistent-storage.rules: Fix blkid invocation for
    CD-ROMs, thanks to Maxim Levitsky for tracking this down! Fix committed to
    GIT HEAD, and cherrypicked. (LP: #431055)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sun, 20 Sep 2009 19:47:17 +0200

udev (147~-1) karmic; urgency=low

  FFE LP: #427356.

  * Update to GIT HEAD (pre 147 release):
    - worker signal mask corrected.  LP: #407428.
    - database format change to avoid path length issues.  LP: #377121.
    - multiple devices may not claim the same /dev names, except with
      symlinks
    - NAME="%k" produces a warning
    - symlinks to udevadm no longer resolve to the original command
    - rules updates.  LP: #281335, LP: #407940, #420015, #426647.

  * Build-depend on gawk, since build fails with mawk.

  * Replace init scripts with Upstart jobs.
  * debian/control:
    - Add missing ${misc:Depends}
    - Bump build-dependency on debhelper for Upstart-aware dh_installinit

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 15 Sep 2009 03:22:11 +0100

udev (146-1) karmic; urgency=low

  * New upstream release:
    - udevadm trigger "--retry-failed" replaced by "--type=failed"
    - RUN "ignore_error" option replaced by "fail_event_on_error"
    - Added HP Presario 2100 keymap.  LP: #20223.
    - Added more keymap coverage for Compaq Evo models.  LP: #35382.
    - Added Fujitsu Amilo M keymap.  LP: #48547.
    - Added Compal Hel80i keymap.  LP: #198530.
    - Added Zepto ZNote keymap.  LP: #400252.
    - Added Everex Stepnote XT5000T keymap.  LP: #400921.
    - Added rules to switch mode of Huawei E1550 GSM modem.  LP: #401655.
    - Various other keymap and modem updates.

  [ Martin Pitt ]
  * debian/control: Add missing Breaks: casper (<< 1.174) to avoid breaking
    upgrades from jaunty in wubi installations. (LP: #400138)

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 25 Aug 2009 13:45:17 +0100

udev (145-1) karmic; urgency=low

  * New upstream release:
    - detach event from worker if killed.
    - make sure a worker finishes its event before exiting.  LP: #396957.
    - handle SIGCHLD before worker messages.
    - use qsort() to sort list rather than by hand (performance).
    - correct mangling of scsi_id return values

  * debian/rules: Update "prep" target to not wipe uncommitted files.
  * debian/libudev-dev.install: Install the restored libtool file
  * debian/libgudev-1.0-dev.install: Install the restored libtool file

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 14 Jul 2009 17:10:38 +0100

udev (143-8) karmic; urgency=low

  * Disable extras for the udeb, since the necessary dependencies aren't
    available.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 01 Jul 2009 10:24:17 +0100

udev (143-7) karmic; urgency=low

  * debian/rules: Add "prep" target to get a buildable source tree. This cares
    for autoconfiscation, and fixes gtk-docs' makefile snippet to get along
    with our separate build trees.
  * debian/rules: Call dh_install with --fail-missing, to avoid regressions
    like the recent dropping of the ConsoleKit helper.
  * debian/udev.install: Add missing ConsoleKit helper. This repairs device
    ACLs.
  * debian/udev.install: Add missing usr/share/doc/udev (README.keymap and
    "writing udev rules")
  * debian/udev.install: Install udev.pc. Not much here, but can't hurt, and
    other software might rely on it.
  * debian/libgudev-1.0-dev.install: Install gtk-doc documentation.
  * debian/libudev-dev.install: Install gtk-doc documentation.
  * debian/copyright: Fix formerly versionless reference to GPL.
  * debian/control: Put libudev-dev into section "libdevel".
  * debian/rules: Call dh_installdeb after dh_makeshlibs, so that the
    debhelper scripts from the latter actually get active. Fixes ldconfig
    calling.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 30 Jun 2009 19:09:38 +0200

udev (143-6) karmic; urgency=low

  * debian/libgudev-1.0-0.install, debian/libgudev-1.0-dev.install:
    - Files are actually installed into /usr/lib already
    - Fix wildcard pkgconfig inclusion
    - Fix wildcard /usr/include inclusion
    - Include static library
    - Drop libtool .la file since it's not generated

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 30 Jun 2009 10:09:42 +0100

udev (143-5) karmic; urgency=low

  * Add missing files.

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 30 Jun 2009 09:47:13 +0100

udev (143-4) karmic; urgency=low

  * debian/udev-udeb.install: Drop /etc/scsi_id.config here too

 -- Scott James Remnant <scott@ubuntu.com>  Mon, 29 Jun 2009 12:12:19 +0100


