=== debian/control ===
Source: udev
Section: admin
Priority: important
Maintainer: Scott James Remnant <scott@ubuntu.com>
Standards-Version: 3.8.0.0
Build-Depends: debhelper (>= 7.3.15ubuntu2), pkg-config, libselinux1-dev (>= 1.28-1), libsepol1-dev, libglib2.0-dev (>= 2.12.0), libusb-dev (>= 1:0.1.12), libacl1-dev, usbutils (>= 0.82), pciutils, xsltproc, docbook-xsl, gtk-doc-tools, gperf, gawk
Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/udev/ubuntu

Package: udev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, module-init-tools (>= 3.2.1-0ubuntu3), initramfs-tools (>= 0.40ubuntu30), procps, adduser, util-linux (>> 2.15~rc2)
Conflicts: hotplug, ifrename, libdevmapper1.02 (<< 2:1.02.08-1ubuntu7), udev-extras (<= 20090618)
Replaces: hotplug, initramfs-tools (<< 0.040ubuntu1), ifrename, udev-extras (<= 20090618)
Suggests: watershed
Breaks: dmsetup (<= 2:1.02.27-4ubuntu5), lvm2 (<= 2.02.39-0ubuntu9), mdadm (<= 2.6.7.1-1ubuntu8), initramfs-tools (<< 0.92bubuntu30), casper (<< 1.174)
Description: rule-based device node and kernel event manager
 udev is a collection of tools and a daemon to manage events received from
 the kernel and deal with them in user-space.  Primarily this involves
 creating and removing device nodes in /dev when hardware is discovered or
 removed from the system.
 .
 Events are received via kernel netlink messaged and processed according to
 rules in /etc/udev/rules.d and /lib/udev/rules.d, altering the name of the
 device node, creating additional symlinks or calling other tools and programs
 including those to load kernel modules and initialise the device.

Package: udev-udeb
XC-Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: rule-based device node and kernel event manager

Package: libudev0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: udev library
 libudev provides a set of functions for accessing the udev database
 and querying sysfs.

Package: libudev-dev
Priority: optional
Section: libdevel
Architecture: any
Depends: libudev0 (= ${Source-Version}), ${shlibs:Depends}, ${misc:Depends}
Description: udev library (development files)
 libudev provides a set of functions for accessing the udev database
 and querying sysfs.
 .
 This package provides a static library and C header files.

Package: libgudev-1.0-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GObject-based wrapper library for libudev
 This library makes it much simpler to use libudev from programs already using
 GObject. It also makes it possible to easily use libudev from other
 programming languages, such as Javascript, because of GObject introspection
 support.
 .
 This package contains the shared libraries.

Package: libgudev-1.0-dev
Section: libdevel
Architecture: any
Depends: libgudev-1.0-0 (= ${binary:Version}), libudev-dev, libglib2.0-dev, pkg-config, ${shlibs:Depends}, ${misc:Depends}
Description: GObject-based wrapper library for libudev -- development files
 This library makes it much simpler to use libudev from programs already using
 GObject. It also makes it possible to easily use libudev from other
 programming languages, such as Javascript, because of GObject introspection
 support.
 .
 This package contains the header and pkgconfig files needed for developing
 applications that use libgudev1.0.
