## udev 147~-6.1

=== debian/changelog ===
udev (147~-6.1) karmic-proposed; urgency=low

  * udev/udev-node.c: Properly close directory handles to fix a major fd leak
    which caused hotplugging to fail entirely. (LP: #463347)
  * udev/udevd.c, handle_inotify(): Fix datatype for FIONREAD ioctl return
    type. It must be an int, not an ssize_t; the latter causes uninitialized
    values and tries to allocate a 15 digit number of bytes, unless the upper
    half of the variable just happens to be zeroed. (Upstream commit
    http://git.kernel.org/?p=linux/hotplug/udev.git;a=commit;h=4daa146b)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 02 Nov 2009 23:47:49 +0100
