=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the udev package.
# Copyright © 2009 Canonical Ltd.
# Author: Scott James Remnant <scott@ubuntu.com>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS

CFLAGS = -Wall -g -fstack-protector -fPIE
LDFLAGS = -Wl,-z,relro -Wl,-z,now -pie

# Disable optimisations if noopt found in $DEB_BUILD_OPTIONS
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
	LDFLAGS += -Wl,-O0
else
	CFLAGS += -Os
	LDFLAGS += -Wl,-O1
endif

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

VERSION = $(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/.*: //p')
UPSTREAM = $(shell echo $(VERSION) | sed -e 's/-[^-]*$$//')


# Configure the package
build-deb/config.status: configure
	[ -d build-deb ] || mkdir build-deb
	cd build-deb && ../configure \
		$(confflags) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		--prefix=/usr \
		--sysconfdir=/etc \
		--sbindir=/sbin \
		--libdir=/usr/lib \
		--with-rootlibdir=/lib \
		--libexecdir=/lib/udev \
		--mandir=\$${datadir}/man \
		--infodir=\$${infodir}/info \
		--with-selinux \
		--enable-static \
		--enable-gtk-doc

# Build the package
build-deb: build-deb/build-stamp
build-deb/build-stamp: build-deb/config.status
	dh_testdir

	$(MAKE) -C build-deb
	touch $@

# Install files into the deb
install-deb: DH_OPTIONS=-Nudev-udeb
install-deb: build-deb
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -v

	$(MAKE) -C build-deb DESTDIR="$(CURDIR)/debian/tmp" install

	# Documentation
	install -m 644 -o root -g root debian/README-etc-rules.d \
		debian/udev/etc/udev/rules.d/README
	install -m 644 -o root -g root debian/README-lib-rules.d \
		debian/udev/lib/udev/rules.d/README

	# Hook into initramfs-tools
	install -m 755 -o root -g root debian/udev.initramfs-hook \
		debian/udev/usr/share/initramfs-tools/hooks/udev
	install -m 755 -o root -g root debian/udev.initramfs-top \
		debian/udev/usr/share/initramfs-tools/scripts/init-top/udev
	install -m 755 -o root -g root debian/udev.initramfs-nfs \
		debian/udev/usr/share/initramfs-tools/scripts/nfs-top/udev
	install -m 755 -o root -g root debian/udev.initramfs-bottom \
		debian/udev/usr/share/initramfs-tools/scripts/init-bottom/udev


# Configure the udeb
build-udeb/config.status: configure
	[ -d build-udeb ] || mkdir build-udeb
	cd build-udeb && ../configure \
		$(confflags) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		--prefix=/usr \
		--sysconfdir=/etc \
		--sbindir=/sbin \
		--libdir=/usr/lib \
		--with-rootlibdir=/lib \
		--libexecdir=/lib/udev \
		--mandir=\$${datadir}/man \
		--infodir=\$${infodir}/info \
		--without-selinux \
		--enable-static \
		--disable-gtk-doc \
		--disable-extras

# Build the package
build-udeb: build-udeb/build-stamp
build-udeb/build-stamp: build-udeb/config.status
	dh_testdir

	$(MAKE) -C build-udeb
	touch $@


# Install files into the udeb
install-udeb: DH_OPTIONS=-pudev-udeb
install-udeb: build-udeb
	dh_testdir
	dh_testroot
	dh_clean -k -Xdebian/tmp
	rm -rf debian/tmp-udeb
	dh_installdirs

	$(MAKE) -C build-udeb DESTDIR="$(CURDIR)/debian/tmp-udeb" install

	# Startup script
	install -m 755 -o root -g root debian/udev.installer-startup \
		debian/udev-udeb/lib/debian-installer/start-udev

	# base-installer script
	install -m 755 -o root -g root debian/udev.base-installer \
		debian/udev-udeb/usr/lib/base-installer.d/05udev


build: build-deb build-udeb

binary: binary-indep binary-arch

# Build architecture-independent files here.
binary-indep:
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: DH_OPTIONS=-a
binary-arch: build install-deb install-udeb
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_installinit --no-start -- start 10 S .
	dh_installinit --name=udev-finish --no-start -- start 37 S .
	dh_installinit --upstart-only --name=udevtrigger --no-start
	dh_installinit --upstart-only --name=udevmonitor --no-start
	dh_install --sourcedir=debian/tmp -Nudev-udeb --fail-missing
	DH_OPTIONS= dh_install --sourcedir=debian/tmp-udeb -pudev-udeb
	dh_link
	dh_strip
	dh_compress
	dh_fixperms -X/lib/udev/devices/
	dh_makeshlibs
	dh_shlibdeps
	dh_installdeb
	DH_OPTIONS= dh_gencontrol -Nlibgudev-1.0-0 -Nlibgudev-1.0-dev
	DH_OPTIONS= dh_gencontrol -plibgudev-1.0-0 -plibgudev-1.0-dev -- "-v1:$(VERSION)"
	dh_md5sums
	dh_builddeb


# Clean up the mess we made
clean:
	dh_testdir

	rm -rf build-deb build-udeb debian/tmp-udeb
	dh_clean 


.PHONY: build-deb build-udeb build install-deb install-udeb \
	binary-indep binary-arch binary clean


# Madness
.PHONY: tarball
tarball: prep
	./configure --enable-gtk-doc
	make all dist
	cp udev-$(UPSTREAM).tar.gz ../udev_$(UPSTREAM).orig.tar.gz
	@echo "Created udev_$(UPSTREAM).orig.tar.gz in parent directory"

.PHONY: package
package: prep
	dpkg-buildpackage -S -i'(^|/)(.bzr|.gitignore|test)($$|/)'

# run this to get a buildable tree
.PHONY: prep
prep:
	gtkdocize --copy
	# fix gtk-doc breakage with separate build tree
	sed -i 's/srcdir/builddir/g' gtk-doc.make
	autoreconf -vi
	rm -r autom4te.cache
