## udev 173

=== debian/changelog ===
udev (173-0ubuntu4) oneiric; urgency=low

  * Set a timeout of 61 seconds when calling udevadm control --exit, to
    ensure that udevd always reaches its *own* timeout first.  If udevadm
    times out before udevd, it exits non-zero, breaking the move of the /dev
    mount; and if we ignore the udevadm failure then udevd might still be
    running, which is the original issue that the patch for bug #624469
    was trying to address.  Raising the timeout doesn't make the boot any
    slower, it just makes sure we let udevd count the 60 seconds instead of
    udevadm.  LP: #818177.
  * debian/patches/race-condition-on-exit: Process events before signals
    in the worker thread, so we don't sit around waiting 60 seconds for an
    already-dead process.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 08 Oct 2011 00:48:54 -0700

udev (173-0ubuntu3) oneiric; urgency=low

  * Include input_id in the initramfs to prevent errors when enumerating
    devices in early init (LP: #831516).

 -- Andy Whitcroft <apw@canonical.com>  Tue, 23 Aug 2011 06:58:23 +0200

udev (173-0ubuntu2) oneiric; urgency=low

  * Add debian/patches/move-input_id-to-default-rules.patch: Fix bluetooth
    mice and keyboards in the X server. Patch cherry-picked from upstream.
    (LP: #827489)

 -- Felix Geyer <debfx-pkg@fobos.de>  Tue, 16 Aug 2011 18:00:41 +0200

udev (173-0ubuntu1) oneiric; urgency=low

  [ Martin Pitt ]
  * New upstream bug fix release.
  * debian/rules: Configure with --enable-udev_acl, the default changed in
    this upstream version because of newer systemd versions.
  * debian/udev.examples: Drop scsi_id.config, this file has been obsolete for
    a long time.

  [ David Henningsson ]
  * To enable jack detection in PulseAudio, make jack detection input
    devices world-readable, just as being done for joysticks (LP: #826662).

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 15 Aug 2011 13:02:20 +0200

udev (172-0ubuntu5) oneiric; urgency=low

  * The kernel won't mount devtmpfs automatically when /init exists, which
    is always the case in the installer, so mount it manually (LP: #817443).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 28 Jul 2011 15:37:48 +0100

udev (172-0ubuntu4) oneiric; urgency=low

  * debian/udev.installer-startup: Create /dev/pts before mounting it
    (LP: #815962).

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 25 Jul 2011 16:53:47 +0100

udev (172-0ubuntu3) oneiric; urgency=low

  * debian/udev-udeb.dirs, debian/udev.dirs, debian/udev.postinst: Get rid of
    the remaining /lib/udev/devices/ stuff:
    - shm: will be symlinked to /run/shm/ by mountall, and avoid having a
      non-world-writable shm (which breaks e. g. ecryptfs)
    - net: created by devtmpfs already
    - pts: mounted as devpts by mountall
  * Drop debian/udev.init. It has a ton of deprecated stuff in it, and with
    upstream supporting systemd and us having upstart scripts there won't ever
    be a time when we go back to a sysvinit script.
  * debian/udev.installer-startup:
    - Drop copying of /lib/udev/devices/. udevd already does this, and it's
      obsolete with devtmpfs anyway.
    - Drop unconditional mounting of a tmpfs on /dev and mknod'ing stuff. We
      already have a devtmpfs there. Only mount devtmpfs if /dev/null doesn't
      exist already.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 14 Jul 2011 09:22:40 +0200

udev (172-0ubuntu2) oneiric; urgency=low

  * extras/cdrom_id/60-cdrom_id.rules: Revert "hd*" hack for powerpc; this
    already is, or should be fixed in the powerpc kernel configuration to use
    the SCSI interface. (Confirmed by Luke).
  * Move rules/rules.d/78-graphics-card.rules to
    debian/local/78-graphics-card.rules and install it in debian/udev.install
    instead of patching Makefile.am
  * Move inline change in rules/rules.d/80-drivers.rules to
    debian/patches/load-fbcon.patch.
  * Move extras/rule_generator/75-persistent-net-generator.rules inline change
    to debian/patches/ignore-eucalyptus-virtual-ifaces.patch.
  * Move libudev/libudev-monitor.c inline change to
    debian/patches/libudev-revert-SOCK_NONBLOCK.patch.
  * Revert autoconf files to upstream state, as we have no further direct
    patches to the upstream build system.
  * debian/source/format: Move to 3.0 (quilt) format.
  * Add debian/patches/use_run_tmpfs: Only use /run/ if it is a tmpfs. Stolen
    from Debian's udev 167-2, thanks Marco d'Itri! (LP: #807306)
  * debian/control: Update Maintainer: field to Ubuntu Developers.
  * debian/control: Bump Standards-Version to 3.9.2.
  * debian/source/options: Ignore *.types files in documentation.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 12 Jul 2011 08:36:12 +0200

udev (172-0ubuntu1) oneiric; urgency=low

  * New upstream release:
    - Now enables kenrel media polling if available. This goes together with
      the changes in udisks 1.0.3 to stop user-space polling if kernel polling
      is enabled.
    - Delete mobile-action-modeswitch, has been deprecated by usb-modeswitch
      for a long time now.
  * debian/rules: Fix build tree copying to cope with new upstream
    "build-aux/" directory.
  * debian/libudev0.symbols: Add new symbols for this release.
  * debian/control: Add gir1.2-gudev-1.0 dependency to libgudev-1.0-dev, as
    per current Debian GI policy.
  * debian/control: Wrap dependencies.
  * debian/control: Add versioned libudev0 dependency to udev. While udevd or
    the probers do not directly link to it (they have an internal copy), they
    still need to be in sync to work properly. (LP: #804577)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 11 Jul 2011 15:28:25 +0200

udev (171-0ubuntu4) oneiric; urgency=low

  [ Colin Watson ]
  * Update Vcs-Bzr field.

  [ Aurélien Couderc ]
  * Use "udevadm control --exit" in the initramfs instead of manually
    killing each udevd process (borrowed from Debian #624469).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 28 Jun 2011 17:50:21 +0100


