=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,7 @@
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
 	confflags += --build=$(DEB_HOST_GNU_TYPE)
@@ -34,22 +35,28 @@
 VERSION = $(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/.*: //p')
 UPSTREAM = $(shell echo $(VERSION) | sed -e 's/-[^-]*$$//')
 
+DPKG_GENSYMBOLS_CHECK_LEVEL=4
+export DPKG_GENSYMBOLS_CHECK_LEVEL
 
 # Configure the package
 build-deb/config.status: configure
 	[ -d build-deb ] || mkdir build-deb
-	cd build-deb && ../configure \
+	# work around gtk-doc not being able to work in a separate build tree
+	# by copying the entire lot
+	cp -a `find -maxdepth 1 ! -name 'build*deb' ! -name 'debian' ! -name '.*'` build-deb
+	cd build-deb && ./configure \
 		$(confflags) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
 		--prefix=/usr \
 		--sysconfdir=/etc \
 		--sbindir=/sbin \
-		--libdir=/usr/lib \
-		--with-rootlibdir=/lib \
+		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
+		--with-rootlibdir=/lib/$(DEB_HOST_MULTIARCH) \
 		--libexecdir=/lib/udev \
 		--mandir=\$${datadir}/man \
 		--infodir=\$${infodir}/info \
 		--with-selinux \
 		--enable-static \
+		--enable-udev_acl \
 		--enable-gtk-doc
 
 # Build the package
@@ -65,10 +72,24 @@
 install-deb: build-deb
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
+	for file in libgudev-1.0-0.install; \
+	do \
+		sed -e"s,\$${DEB_HOST_MULTIARCH},${DEB_HOST_MULTIARCH},g" \
+			debian/$${file}.in > debian/$$file; \
+	done
 	dh_installdirs -v
 
 	$(MAKE) -C build-deb DESTDIR="$(CURDIR)/debian/tmp" install
+
+	# we install gudev into /usr/lib/, fix link
+	T=`readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgudev-1.0.so`; \
+	  rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgudev-1.0.so; \
+	  ln -s /usr/lib/$(DEB_HOST_MULTIARCH)/`basename $$T` debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgudev-1.0.so
+	# Fix up dependency_libs in libtool .la files
+	for file in `find debian/tmp/usr/lib/ -name \*.la`; do \
+		sed -i "/dependency_libs/ s/'.*'/''/" $$file ; \
+	done
 
 	# Documentation
 	install -m 644 -o root -g root debian/README-etc-rules.d \
@@ -102,8 +123,7 @@
 		--infodir=\$${infodir}/info \
 		--without-selinux \
 		--enable-static \
-		--disable-gtk-doc \
-		--disable-extras
+		--disable-gtk-doc
 
 # Build the package
 build-udeb: build-udeb/build-stamp
@@ -119,7 +139,7 @@
 install-udeb: build-udeb
 	dh_testdir
 	dh_testroot
-	dh_clean -k -Xdebian/tmp
+	dh_prep -Xdebian/tmp
 	rm -rf debian/tmp-udeb
 	dh_installdirs
 
@@ -154,14 +174,18 @@
 	dh_installinit --name=udev-finish --no-start -- start 37 S .
 	dh_installinit --upstart-only --name=udevtrigger --no-start
 	dh_installinit --upstart-only --name=udevmonitor --no-start
-	dh_install --sourcedir=debian/tmp -Nudev-udeb --fail-missing
-	DH_OPTIONS= dh_install --sourcedir=debian/tmp-udeb -pudev-udeb
+	dh_installinit --upstart-only --name=udev-fallback-graphics --no-start
+	dh_install --sourcedir=debian/tmp -Nudev-udeb -Nlibudev0-udeb --fail-missing
+	DH_OPTIONS= dh_install --sourcedir=debian/tmp-udeb -pudev-udeb -plibudev0-udeb
 	dh_link
 	dh_strip
 	dh_compress
 	dh_fixperms -X/lib/udev/devices/
-	dh_makeshlibs
+	DH_OPTIONS= dh_makeshlibs -plibudev0 -V 'libudev0 (>= 147)' --add-udeb=libudev0-udeb
+	DH_OPTIONS= dh_makeshlibs -plibgudev-1.0-0 -V 'libgudev-1.0-0 (>= 147)'
+	DH_OPTIONS= dh_makeshlibs -Nlibudev0 -Nlibgudev-1.0-0
 	dh_shlibdeps
+	dh_girepository
 	dh_installdeb
 	DH_OPTIONS= dh_gencontrol -Nlibgudev-1.0-0 -Nlibgudev-1.0-dev
 	DH_OPTIONS= dh_gencontrol -plibgudev-1.0-0 -plibgudev-1.0-dev -- "-v1:$(VERSION)"
@@ -189,16 +213,10 @@
 	cp udev-$(UPSTREAM).tar.gz ../udev_$(UPSTREAM).orig.tar.gz
 	@echo "Created udev_$(UPSTREAM).orig.tar.gz in parent directory"
 
-.PHONY: package
-package: prep
-	dpkg-buildpackage -S -i'(^|/)(.bzr|.gitignore|test)($$|/)'
-
 # run this to get a buildable tree
 .PHONY: prep
 prep:
 	gtkdocize --copy
-	# fix gtk-doc breakage with separate build tree
-	sed -i 's/srcdir/builddir/g' gtk-doc.make
 	autoreconf -vi
 	rm -r autom4te.cache
